
# coding: utf-8

# # Lez 6

# ## File

# I file hanno dei caratteri che formattano il testo, questi caratteri fanno parte del file.
# La riga è l'elemento atomico che noi possiamo gestire in un file. Di solito un file viene letto per riga. I caratteri devono essere codificati.
# Caratteri ASCII 1 byte, UNICODE 1 o 2 o più. In europa molto usato l'"UTF-8", che se codifica caratteri sempre li memorizza con la memoria dell'ASCII.
# Noi useremo encoding="UTF-8", ma non è detto che vi capitano pagine che non si riescano a codificare con l'encoding con UTF-8.
open(file, mode='r', buffering=-1, encoding=None, errors=None, newline=None, closefd=True, opener=None)
# In[19]:

open("Esempi/provaTesto.txt")


# In[20]:

f = open("Esempi/provaTesto.txt")


# In[21]:

s = f.read()
s


# In[22]:

print(s)


# In[23]:

f.close()


# In[25]:

f.read()

!!!Tutto quello che avete imparato sulle liste potete applicarlo sui file!!!
# In[26]:

'un' in s


# In[27]:

f = open("Esempi/provaTesto.txt")


# In[28]:

s2=f.readlines()
s2

Quindi f.read() costruisce una stringa mentre f.readlines() mi da una lista, la scelta dipenderà da quello che dovete fare! Un terzo modo è usare il for
# In[29]:

# leggo il file per riga usando un ciclo for
f = open("Esempi/provaTesto.txt")
i=0
for riga in f:
    print(i,riga)      
    i=i+1
f.close()


# In[30]:

f = open("Esempi/provaTesto.txt")
for i in range(5):
    print(i)
    print(f.read(20))
    


# In[31]:

f.read()


# In[34]:

f = open("Esempi/provaTesto.txt")


# In[35]:

#  funzione che legge per riga un file
def stampa(testo):
    i=0
    for riga in testo:
        print(i,riga)      
        i=i+1


# In[36]:

stampa(open("Esempi/provaTesto.txt"))


# In[37]:

stampa([1,'cia',4.3,[3,4,5]])


# Usando read a split posso crearmi una lista in cui ogni elemento della lista è una parola?
# 

# In[38]:

f = open("Esempi/provaTesto.txt")
s = f.read()
l = s.split('i')
print(l)


# ### Esercizio
# Crea una funzione che prende in ingresso una file e crea una lista ordinata di parole distinte

# In[39]:

def listaSenzaDoppionni(file):
    f=open(file)
    s=f.read();
    sv=s.split()
    risposta=[]
    for c in sv:
        if c not in risposta:
            risposta.append(c)
    risposta.sort()
    return risposta


# In[40]:

listaSenzaDoppionni("Esempi/provaTesto.txt")


# ### File Excel
# 
# Salvateli come CSV, Comma Separated Valued

# In[47]:

f = open("Esempi/dadi.csv")
for riga in f:
    print(riga)


# In[60]:

f = open("Esempi/dadi.csv")
listaCSV=[]
for riga in f:
    s = riga.split(';')
    print(s)


# In[61]:

f = open("Esempi/dadi.csv")
listaCSV=[]
for riga in f:
    s = riga.strip().split(';')
    print(s)


# In[54]:

f = open("Esempi/dadi.csv")
listaCSV=[]
for riga in f:
    s = riga.strip().split(';')
    listaCSV.append(s)
print(listaCSV)


# In[58]:

def creaListaCSV(file):
    f = open(file) 
    listaCSV=[]
    for riga in f:
        s = riga.strip().split(';')
        listaCSV.append(s)
    return(listaCSV)


# In[62]:

print(creaListadaCSV("Esempi/dadi.csv"))


# In[63]:

f=open('provaScrittura.txt','w')


# In[64]:

f.write('Adesso ti scrivo un file e questa cosa è proprio incredibile!!!')


# In[65]:

f.close()


# In[66]:

f=open('provaScrittura.txt')


# In[67]:

f.read()

